<template>
  <div class="allMessages">
    <div class="message" v-for="message in messages" :key="message.id">
      <MessageSender
        :message="message"
        v-if="message.sender_id === userId"
      ></MessageSender>
      <MessageReceiver
        :message="message"
        v-if="message.sender_id !== userId"
      ></MessageReceiver>
    </div>
  </div>
  <form class="sendMessage" @submit.prevent="send" novalidate>
    <FormField
      id="message"
      inputType="text"
      v-model.trim="content"
      :required="true"
    ></FormField>
    <div class="buttons">
      <ActionButton type="submit">Send</ActionButton>
    </div>
  </form>
</template>

<script>
import axios from "axios";
import store from "../../store/auth";
import MessageSender from "../molecules/MessageSender.vue";
import MessageReceiver from "../molecules/MessageReceiver.vue";
import FormField from "../molecules/FormField.vue";
import ActionButton from "../atoms/ActionButton.vue";

export default {
  components: { MessageSender, MessageReceiver, FormField, ActionButton },
  data() {
    return {
      content: this.content,
    };
  },
  props: {
    messages: {
      type: Object,
    },
    playerId: {
      validator(value) {
        return /([0-9])/.test(value);
      },
    },
    id: {
      validator(value) {
        return /([0-9])/.test(value);
      },
    },
  },
  computed: {
    userId() {
      return store.getters["auth/getUser"].id;
    },
  },
  methods: {
    async send() {
      if (this.content !== "") {
        if (store.getters["auth/getUser"].role === "player") {
          await axios.post(`api/games/${this.id}/messages/send`, {
            content: this.content,
            receiver: "supervisors",
          });
        } else {
          await axios.post(`api/games/${this.id}/messages/send`, {
            content: this.content,
            receiver: [this.playerId],
          });
        }

        this.$router.go();
      }
    },
  },
};
</script>

<style lang="scss">
.allMessages {
  display: flex;
  flex-direction: column;
  overflow-y: scroll;
  align-items: flex-end;
  height: 20rem;
}
.message {
  width: 100%;
}
.buttons {
  display: flex;
  flex-direction: row;
  justify-content: space-evenly;
}

.sendMessage {
  display: flex;
  flex-direction: row;
  justify-content: space-evenly;
  .FormField {
    width: 80%;
    margin: 0;
    margin-left: 10%;
  }
  .buttons .actionButton {
    width: 5rem;
    margin-top: 0.7rem;
  }
}
</style>
